package ipm.ipmworks.control;

import com.mongodb.client.gridfs.GridFSFindIterable;
import com.mongodb.client.gridfs.model.GridFSFile;
import ipm.ipmworks.model.Resource;
import ipm.ipmworks.repository.ResourceRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.data.mongodb.gridfs.GridFsTemplate;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.function.Consumer;

@RestController
@RequestMapping(value="/admin")
public class AdminResourceController {
    @Autowired
    ResourceRepository resourceRepository;

    @Autowired
    GridFsTemplate gridFsTemplate;

    @RequestMapping(value="/getResourceForApproval", method= RequestMethod.GET)
    public List<Resource> getResourceForApproval(){
        return resourceRepository.findByApprovedIsFalse();
    }

    @GetMapping("/approve/{id}")
    public void approveResource(@PathVariable("id") String idResource){
        Optional<Resource> resource = resourceRepository.findById(idResource);
        if (resource.isPresent()){
            Resource r = resource.get();
            r.setApproved(true);
            r.setHide(false);
            resourceRepository.save(r);
        }
    }
    @GetMapping("/archive/{id}")
    public void archiveResource(@PathVariable("id") String idResource){
        Optional<Resource> resource = resourceRepository.findById(idResource);
        if (resource.isPresent()){
            Resource r = resource.get();
            r.setApproved(false);
            r.setHide(true);
            resourceRepository.save(r);
        }
    }
    @GetMapping("/delete/{id}")
    public void deleteResource(@PathVariable("id") String idResource){
       resourceRepository.deleteById(idResource);
        Query query = new Query();
        query.addCriteria(Criteria.where("metadata.idResource").is(idResource));
        gridFsTemplate.delete(query);
    }
}
