package ipm.ipmworks.control;

import ipm.ipmworks.model.*;
import ipm.ipmworks.repository.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping(value="/codebooks")
public class CodebooksController {

    @Autowired
    RegionRepository cr;

    @Autowired
    ResourceTypeRepository rtr;

    @Autowired
    SectorRepository sr;

    @Autowired
    PestRepository pr;

    @Autowired
    CropRepository crR;

    @Autowired
    LanguageRepository lr;

    @Autowired
    ProjectRepository prR;


    @RequestMapping(value="/saveResourceType", method= RequestMethod.POST)
    public ResourceType saveResourceType(@RequestBody ResourceType rt){
        ResourceType resType= rtr.save(rt);
        return resType;
    }

    @RequestMapping(value="/getAllResourceTypes", method=RequestMethod.GET)
    public List<ResourceType> getResourceTypes(){
        return rtr.findAll(Sort.by(Sort.Direction.ASC, "name"));
    }

    @RequestMapping(value="/saveSector", method= RequestMethod.POST)
    public Sector saveSector(@RequestBody Sector s){
        Sector sector= sr.save(s);
        return sector;
    }

    @RequestMapping(value="/getAllSectors", method=RequestMethod.GET)
    public List<Sector> getSecotrs(){
        return sr.findAll(Sort.by(Sort.Direction.ASC, "name"));
    }

    @RequestMapping(value="/getAllRegions", method=RequestMethod.GET)
    public List<Region> getRegions(){return cr.findAll(Sort.by(Sort.Direction.ASC, "name"));
    }

    @RequestMapping(value="/savePest", method= RequestMethod.POST)
    public Pest savePest(@RequestBody Pest p){
        Pest pest = pr.save(p);
        return pest;
    }

    @RequestMapping(value="/getAllPests", method=RequestMethod.GET)
    public List<Pest> getPests(){
        return pr.findAll(Sort.by(Sort.Direction.ASC, "commonName"));
    }

    @RequestMapping(value="/saveCrop", method= RequestMethod.POST)
    public Crop saveCrop(@RequestBody Crop c){
        Crop crop = crR.save(c);
        return crop;
    }

    @RequestMapping(value="/getAllCrops", method=RequestMethod.GET)
    public List<Crop> getCrops(){
        return crR.findAll(Sort.by(Sort.Direction.ASC, "commonName"));
    }

    @RequestMapping(value="/saveLanguage", method= RequestMethod.POST)
    public Language saveLanguage(@RequestBody Language l){
        Language lang = lr.save(l);
        return lang;
    }

    @RequestMapping(value="/getAllLanguages", method=RequestMethod.GET)
    public List<Language> getLanguages(){
        return lr.findAll(Sort.by(Sort.Direction.ASC, "name"));
    }

    @RequestMapping(value="/saveProject", method= RequestMethod.POST)
    public Project saveProject(@RequestBody Project p){
        Project proj = prR.save(p);
        return proj;
    }

    @RequestMapping(value="/getAllProjects", method=RequestMethod.GET)
    public List<Project> getProjects(){
        return prR.findAll(Sort.by(Sort.Direction.ASC, "name"));
    }

}
