package ipm.ipmworks.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateTimeDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import lombok.Getter;
import lombok.Setter;
import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.Transient;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Document(collection="Resource")
@Getter
@Setter

public class Resource {
    @Id
    private String idResource;
    private String resourceOrigin;
    private String resourceName;
    private String description;
    private String descriptionNative;
    private ResourceType resourceType;
    private String contactInstitution;
    private String contactName;
    private String contactEmail;
    private String contactPhone;
    private String contactAddress;

    private List<Link> links = new ArrayList<Link>();
    private String youtube;
    private List<Map> files = new ArrayList();
    private String project;
    private String projectWeb;
    private String projectGrantNo;
    private Language language;
    private List<Sector> sectors = new ArrayList<Sector>();
    private List<Region> regions = new ArrayList<Region>();
    private String citation;
    private String mainURL;
    private User approvedBy;
    private List<Pest> pests = new ArrayList<Pest>();
    private List<Crop> crops = new ArrayList<Crop>();
    private LocalDateTime creationDate;
    private boolean approved;
    private boolean canEdit;
    private boolean external;
    private boolean hide;
}
