package ipm.ipmworks.security;

import ipm.ipmworks.model.User;
import ipm.ipmworks.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import java.util.Optional;

@Service
public class IPMUserDetailsService implements UserDetailsService {

@Autowired
    UserRepository userRepository;
    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        Optional<User> user = userRepository.findByUsername(username);
        IPMUserDetailsImpl ipmUserDetails = null;
        if (user.isPresent()) {
            ipmUserDetails = new IPMUserDetailsImpl(user.get());
            return ipmUserDetails;
        } else {
            throw new UsernameNotFoundException("Not found: " + username);
        }
    }
    }


